var query = { active: true, currentWindow: true };

function callback(tabs) {
  var currentTab = tabs[0];
  
  var url = currentTab.url;

  $('#url').val(url);
  $.post( "https://uncoverweb.com/script.php", {
    action:'getComments',        
    url:url
    }, function (data) {
        $('#loading').hide();
        if (data!='') {
            var comment_container = $('#comments');
            comment_container.html(data);
            addReplyAction();
            comment_container.scrollTop(comment_container[0].scrollHeight);
        }
        else {
            $('#comments').html('<span id="no_comments">No one has left a comment on this page yet.</span>');
        }
    });  
}


chrome.tabs.query(query, callback);


$('#comment-form').submit(function (event) {

    $('#event-message').html('');
    event.preventDefault();

    var input = $('#add-comment');
    var text = input.val();
    var url = $('#url').val();
    var token = $('#auth-token').val();
    var reply_id = $('#reply-id').val();

    $.post( "https://uncoverweb.com/script.php", { 
        action: 'addComment', 
        url:url, 
        text:text,
        reply_id:reply_id,
        token:token
    }, function (data) {
        if (data=='error')
        {
            $('#event-message').html('error');
        }
        else {
            $('#no_comments').hide();
            if (reply_id==0) {
                $('#comments').append(data);
            }
            else {
                $('#comment-'+reply_id+' .comment-replies').append(data);
                $('#reply-comment-text').html('');
                $('#reply-comment').hide();
                $('#reply-id').val(0);
            }
            input.val('');
            addReplyAction();
        }
    });
});

function addReplyAction (){
    $('.add-reply').click(function(event){
        event.preventDefault();
        var id = $(this).attr('data-comment-id');
        var reply_id = $(this).attr('data-replyto-id');
        console.log(reply_id);
        var commentText = $('#comment-text-'+reply_id).text();
        console.log(commentText);
        $('#reply-comment-text').html(commentText);
        $('#reply-comment').show();
        $('#reply-id').val(id);
    });       
}

$('#cancel-reply').click(function(event){
    event.preventDefault();
    $('#reply-comment-text').html('');
    $('#reply-comment').hide();
    $('#reply-id').val(0);
}); 


chrome.storage.sync.get(['uncover_token'], function(result) {
    $('#event-message').html('');
    if (result.uncover_token) {        

        $.post( "https://uncoverweb.com/script.php", { 
            action: 'checkToken', 
            token:result.uncover_token
        }, function (data) {
            if (data=='error') {
                $('#login-block').show();
                $('#event-message').html('Wrong token!');
            }
            else {
                $('#auth-token').val(result.uncover_token);
                if (data==1) {
                    $('#replacer').prop('checked','checked');
                }
                $('#comment-form').show();
            }
        });

    }
    else {
        $('#login-block').show();
    }
    
});


$('#register-link').click(function(event){
    event.preventDefault();
    $('#event-message').html('');
    $(this).parent().hide();
    $('#login-form').hide();
    $('#register-form').show();
});


$('#register').click(function(event){

    event.preventDefault();
    $('#event-message').html('');

    var name = $('#register-name').val();
    var email = $('#register-email').val();
    var password = $('#register-password').val();
    var confirm = $('#confirm-password').val();

    if (name!='' && email!='' && password!='' && password==confirm) {
        $.post( "https://uncoverweb.com/script.php", { 
            action: 'register', 
            name:name,
            email:email, 
            password:password
        }, function (data) {        
            if (data=='exist') {
                $('#event-message').html('Error! User exist.');
            }
            else {
                $('#login-block').hide();
                $('#comment-form').show();
                $('#auth-token').val(data);

                chrome.storage.sync.set({uncover_token: data}, function() {
                    console.log('Token is set to ' + data);
                });
            }
        });
    }
    else {
        $('#event-message').html('Something wrong!');
    }

});

$('#login').click(function(event){

    event.preventDefault();
    $('#event-message').html('');

    var email = $('#login-email').val();
    var password = $('#login-password').val();

    if (email!='' && password!='') {
        $.post( "https://uncoverweb.com/script.php", { 
            action: 'login', 
            email:email, 
            password:password
        }, function (data) {        
            if (data=='error') {
                $('#event-message').html('Error login or password.');
            }
            else {
                // var obj = JSON.parse(data);

                $('#login-block').hide();
                $('#comment-form').show();
                $('#auth-token').val(data);

                chrome.storage.sync.set({uncover_token: data}, function() {
                    console.log('Token is set to ' + data);
                });
            }
        });
    }
    else {
        $('#event-message').html('Something wrong!');
    }

});

$('#replacer').change(function(){
    var replace = 0;
    if ($(this).prop('checked')) {
        replace = 1;
        chrome.storage.sync.set({uncover_replace: 1});
    }
    else {
        chrome.storage.sync.set({uncover_replace: 0});
    }

    var token = $('#auth-token').val();
    
    // console.log(replace);

    $.post( "https://uncoverweb.com/script.php", { 
        action: 'setReplacer', 
        replace:replace,
        token:token
    }, function (data) {        
        if (data=='error') {
            $('#event-message').html('Error.');
        }
        else {
            $('#event-message').html(data);
        }
    });
});